import React from 'react';
import createReactClass from 'create-react-class';
import PropTypes from 'prop-types';
import ImmutablePropTypes from 'react-immutable-proptypes';

var Control = createReactClass({
  displayName: 'Control',

  propTypes: {
    onChange: PropTypes.func.isRequired,
    forID: PropTypes.string.isRequired,
    value: PropTypes.node,
    setActiveStyle: PropTypes.func.isRequired,
    setInactiveStyle: PropTypes.func.isRequired,
    classNameWrapper: PropTypes.string.isRequired,
    field: ImmutablePropTypes.mapContains({
      default: PropTypes.string
    }).isRequired
  },

  getDefaultProps: function getDefaultProps() {
    return { value: '' };
  },
  render: function render() {
    var _props = this.props,
        forID = _props.forID,
        field = _props.field,
        value = _props.value,
        setActiveStyle = _props.setActiveStyle,
        setInactiveStyle = _props.setInactiveStyle,
        _onChange = _props.onChange,
        classNameWrapper = _props.classNameWrapper;

    var currentValue = value || field.get('default');
    return React.createElement(
      'label',
      {
        onBlur: setInactiveStyle,
        onFocus: setActiveStyle,
        htmlFor: forID,
        className: classNameWrapper,
        style: { borderColor: currentValue }
      },
      React.createElement('input', {
        id: forID,
        value: currentValue,
        type: 'color',
        onChange: function onChange(e) {
          return _onChange(e.target.value);
        }
      })
    );
  }
});

var index = {
  Control: Control
};

export default index;
